<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleMocoTrack.m</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleMocoTrack_8m-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleMocoTrack.m</div>  </div>
</div><!--header-->
<div class="contents">
<p>This is an example using the MocoTrack tool with a complex model to track walking.</p>
<div class="fragment"><div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line">% <a class="code" href="namespaceOpenSim.html">OpenSim</a> Moco: exampleMocoTrack.m                                           %</div>
<div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line">% Copyright (c) 2019 Stanford University and the Authors                     %</div>
<div class="line">%                                                                            %</div>
<div class="line">% Author(s): Nicholas Bianco                                                 %</div>
<div class="line">%                                                                            %</div>
<div class="line">% Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may    %</div>
<div class="line">% not use <span class="keyword">this</span> file except in compliance with the License. You may obtain a  %</div>
<div class="line">% copy of the License at http:<span class="comment">//www.apache.org/licenses/LICENSE-2.0          %</span></div>
<div class="line">%                                                                            %</div>
<div class="line">% Unless required by applicable law or agreed to in writing, software        %</div>
<div class="line">% distributed under the License is distributed on an <span class="stringliteral">&quot;AS IS&quot;</span> BASIS,          %</div>
<div class="line">% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   %</div>
<div class="line">% See the License <span class="keywordflow">for</span> the specific language governing permissions and        %</div>
<div class="line">% limitations under the License.                                             %</div>
<div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line"> </div>
<div class="line">% This example features two different tracking problems solved using the</div>
<div class="line">% MocoTrack tool. </div>
<div class="line">%  - The first problem demonstrates the basic usage of the tool interface</div>
<div class="line">%    to solve a torque-driven marker tracking problem. </div>
<div class="line">%  - The second problem shows how to customize a muscle-driven state tracking </div>
<div class="line">%    problem using more advanced features of the tool interface.</div>
<div class="line">%</div>
<div class="line">% This example also shows how to use the osimMocoTrajectoryReport.m utility to</div>
<div class="line">% create a PDF report of plots of a solution.</div>
<div class="line">%</div>
<div class="line">% See the README.txt next to this file for more information.</div>
<div class="line"> </div>
<div class="line">function exampleMocoTrack()</div>
<div class="line"> </div>
<div class="line">% Solve the torque-driven marker tracking problem.</div>
<div class="line">% This problem takes a few minutes to solve.</div>
<div class="line">torqueDrivenMarkerTracking();</div>
<div class="line"> </div>
<div class="line">% Solve the muscle-driven state tracking problem.</div>
<div class="line">% This problem could take an hour or more to solve, depending on the number of</div>
<div class="line">% processor cores available for parallelization. With 12 cores, it takes around</div>
<div class="line">% 25 minutes.</div>
<div class="line">muscleDrivenStateTracking();</div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line"><span class="keyword">function</span> torqueDrivenMarkerTracking()</div>
<div class="line"> </div>
<div class="line">import org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">% Create and name an instance of the MocoTrack tool.</div>
<div class="line">track = MocoTrack();</div>
<div class="line">track.setName(&quot;torque_driven_marker_tracking&quot;);</div>
<div class="line"> </div>
<div class="line">% Construct a ModelProcessor and add it to the tool. ModelProcessors</div>
<div class="line">% accept a base model and allow you to easily modify the model by appending</div>
<div class="line">% ModelOperators. Operations are performed in the order that they are</div>
<div class="line">% appended to the model.</div>
<div class="line">% Create the base Model by passing in the model file.</div>
<div class="line">modelProcessor = ModelProcessor(&quot;subject_walk_armless.osim&quot;);</div>
<div class="line">% Add ground reaction external loads in lieu of a ground-contact model.</div>
<div class="line">modelProcessor.append(ModOpAddExternalLoads(&quot;grf_walk.xml&quot;));</div>
<div class="line">% Remove all the muscles in the model&#39;s ForceSet.</div>
<div class="line">modelProcessor.append(ModOpRemoveMuscles());</div>
<div class="line">% Add CoordinateActuators to the model degrees-of-freedom. This</div>
<div class="line">% ignores the pelvis coordinates which already have residual </div>
<div class="line">% CoordinateActuators.</div>
<div class="line">modelProcessor.append(ModOpAddReserves(250));</div>
<div class="line">track.setModel(modelProcessor);</div>
<div class="line"> </div>
<div class="line">% Use this convenience function to set the MocoTrack markers reference</div>
<div class="line">% directly from a TRC file. By default, the markers data is filtered at</div>
<div class="line">% 6 Hz and if in millimeters, converted to meters.</div>
<div class="line">track.setMarkersReferenceFromTRC(&quot;marker_trajectories.trc&quot;);</div>
<div class="line"> </div>
<div class="line">% There is marker data in the &#39;marker_trajectories.trc&#39; associated with</div>
<div class="line">% model markers that no longer exists (i.e. markers on the arms). Set this</div>
<div class="line">% flag to avoid an exception from being thrown.</div>
<div class="line">track.set_allow_unused_references(true);</div>
<div class="line"> </div>
<div class="line">% Increase the global marker tracking weight, which is the weight</div>
<div class="line">% associated with the internal MocoMarkerTrackingGoal term.</div>
<div class="line">track.set_markers_global_tracking_weight(10);</div>
<div class="line"> </div>
<div class="line">% Increase the tracking weights for individual markers in the data set </div>
<div class="line">% placed on bony landmarks compared to markers located on soft tissue.</div>
<div class="line">markerWeights = MocoWeightSet();</div>
<div class="line">markerWeights.cloneAndAppend(MocoWeight(&quot;R.ASIS&quot;, 20));</div>
<div class="line">markerWeights.cloneAndAppend(MocoWeight(&quot;L.ASIS&quot;, 20));</div>
<div class="line">markerWeights.cloneAndAppend(MocoWeight(&quot;R.PSIS&quot;, 20));</div>
<div class="line">markerWeights.cloneAndAppend(MocoWeight(&quot;L.PSIS&quot;, 20));</div>
<div class="line">markerWeights.cloneAndAppend(MocoWeight(&quot;R.Knee&quot;, 10));</div>
<div class="line">markerWeights.cloneAndAppend(MocoWeight(&quot;R.Ankle&quot;, 10));</div>
<div class="line">markerWeights.cloneAndAppend(MocoWeight(&quot;R.Heel&quot;, 10));</div>
<div class="line">markerWeights.cloneAndAppend(MocoWeight(&quot;R.MT5&quot;, 5));</div>
<div class="line">markerWeights.cloneAndAppend(MocoWeight(&quot;R.Toe&quot;, 2));</div>
<div class="line">markerWeights.cloneAndAppend(MocoWeight(&quot;L.Knee&quot;, 10));</div>
<div class="line">markerWeights.cloneAndAppend(MocoWeight(&quot;L.Ankle&quot;, 10));</div>
<div class="line">markerWeights.cloneAndAppend(MocoWeight(&quot;L.Heel&quot;, 10));</div>
<div class="line">markerWeights.cloneAndAppend(MocoWeight(&quot;L.MT5&quot;, 5));</div>
<div class="line">markerWeights.cloneAndAppend(MocoWeight(&quot;L.Toe&quot;, 2));</div>
<div class="line">track.set_markers_weight_set(markerWeights);</div>
<div class="line"> </div>
<div class="line">% Initial time, final time, and mesh interval. The number of mesh points</div>
<div class="line">% used to discretize the problem is computed internally using these values.</div>
<div class="line">track.set_initial_time(0.81);</div>
<div class="line">track.set_final_time(1.65);</div>
<div class="line">track.set_mesh_interval(0.05);</div>
<div class="line"> </div>
<div class="line">% Solve! Use track.solve() to skip visualizing.</div>
<div class="line">solution = track.solveAndVisualize();</div>
<div class="line"> </div>
<div class="line">solution.write(&#39;exampleMocoTrack_markertracking_solution.sto&#39;);</div>
<div class="line"> </div>
<div class="line">% Generate a PDF report containing plots of the variables in the solution.</div>
<div class="line">% For details, see osimMocoTrajectoryReport.m in Moco&#39;s</div>
<div class="line">% Resources/Code/Matlab/Utilities folder.</div>
<div class="line">model = modelProcessor.process();</div>
<div class="line">report = osimMocoTrajectoryReport(model, ...</div>
<div class="line">            &#39;exampleMocoTrack_markertracking_solution.sto&#39;);</div>
<div class="line">reportFilepath = report.generate();</div>
<div class="line">open(reportFilepath);</div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">function muscleDrivenStateTracking()</div>
<div class="line"> </div>
<div class="line">import org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">% Create and name an instance of the MocoTrack tool. </div>
<div class="line">track = MocoTrack();</div>
<div class="line">track.setName(&quot;muscle_driven_state_tracking&quot;);</div>
<div class="line"> </div>
<div class="line">% Construct a ModelProcessor and set it on the tool. The default</div>
<div class="line">% muscles in the model are replaced with optimization-friendly</div>
<div class="line">% DeGrooteFregly2016Muscles, and adjustments are made to the default muscle</div>
<div class="line">% parameters.</div>
<div class="line">modelProcessor = ModelProcessor(&quot;subject_walk_armless.osim&quot;);</div>
<div class="line">modelProcessor.append(ModOpAddExternalLoads(&quot;grf_walk.xml&quot;));</div>
<div class="line">modelProcessor.append(ModOpIgnoreTendonCompliance());</div>
<div class="line">modelProcessor.append(ModOpReplaceMusclesWithDeGrooteFregly2016());</div>
<div class="line">% Only valid for DeGrooteFregly2016Muscles.</div>
<div class="line">modelProcessor.append(ModOpIgnorePassiveFiberForcesDGF());</div>
<div class="line">% Only valid for DeGrooteFregly2016Muscles.</div>
<div class="line">modelProcessor.append(ModOpScaleActiveFiberForceCurveWidthDGF(1.5));</div>
<div class="line">track.setModel(modelProcessor);</div>
<div class="line"> </div>
<div class="line">% Construct a TableProcessor of the coordinate data and pass it to the </div>
<div class="line">% tracking tool. TableProcessors can be used in the same way as</div>
<div class="line">% ModelProcessors by appending TableOperators to modify the base table.</div>
<div class="line">% A TableProcessor with no operators, as we have here, simply returns the</div>
<div class="line">% base table.</div>
<div class="line">track.setStatesReference(TableProcessor(&quot;coordinates.sto&quot;));</div>
<div class="line">track.set_states_global_tracking_weight(10);</div>
<div class="line"> </div>
<div class="line">% This setting allows extra data columns contained in the states</div>
<div class="line">% reference that don&#39;t correspond to model coordinates.</div>
<div class="line">track.set_allow_unused_references(true);</div>
<div class="line"> </div>
<div class="line">% Since there is only coordinate position data in the states references, this</div>
<div class="line">% setting is enabled to fill in the missing coordinate speed data using</div>
<div class="line">% the derivative of splined position data.</div>
<div class="line">track.set_track_reference_position_derivatives(true);</div>
<div class="line"> </div>
<div class="line">% Initial time, final time, and mesh interval.</div>
<div class="line">track.set_initial_time(0.81);</div>
<div class="line">track.set_final_time(1.65);</div>
<div class="line">track.set_mesh_interval(0.08);</div>
<div class="line"> </div>
<div class="line">% Instead of calling solve(), call initialize() to receive a pre-configured</div>
<div class="line">% MocoStudy <span class="keywordtype">object</span> based on the settings above. Use this to customize the</div>
<div class="line">% problem beyond the MocoTrack interface.</div>
<div class="line">study = track.initialize();</div>
<div class="line"> </div>
<div class="line">% Get a reference to the MocoControlGoal that is added to every MocoTrack</div>
<div class="line">% problem by default.</div>
<div class="line">problem = study.updProblem();</div>
<div class="line">effort = MocoControlGoal.safeDownCast(problem.updGoal(&quot;control_effort&quot;));</div>
<div class="line"> </div>
<div class="line">% Put a large weight on the pelvis CoordinateActuators, which act as the</div>
<div class="line">% residual, or &#39;hand-of-god&#39;, forces which we would like to keep as small</div>
<div class="line">% as possible.</div>
<div class="line">model = modelProcessor.process();</div>
<div class="line">model.initSystem();</div>
<div class="line">forceSet = model.getForceSet();</div>
<div class="line">for i = 0:forceSet.getSize()-1</div>
<div class="line">   forcePath = forceSet.get(i).getAbsolutePathString();</div>
<div class="line">   if contains(<span class="keywordtype">string</span>(forcePath), &#39;pelvis&#39;)</div>
<div class="line">       effort.setWeightForControl(forcePath, 10);</div>
<div class="line">   end</div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line">% Solve and visualize.</div>
<div class="line">solution = study.solve();</div>
<div class="line">study.visualize(solution);</div>
<div class="line"> </div>
<div class="line">end</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="ttc" id="anamespaceOpenSim_html"><div class="ttname"><a href="namespaceOpenSim.html">OpenSim</a></div><div class="ttdoc">The Moco interface is contained within the OpenSim namespace.</div><div class="ttdef"><b>Definition:</b> ActivationCoordinateActuator.h:30</div></div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:01 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
